<template>
    <div class="edit-view">
        <el-form
            :model="formData"
            :rules="rules"
            ref="form"
            label-width="139px"
            label-position="right"
            size="small"
            style="max-width: 500px;"
        >
            <el-form-item prop="recordSpecialtyId" label="recordSpecialtyId">
                <el-input v-model="formData.recordSpecialtyId"></el-input>
            </el-form-item>
            <el-form-item prop="name" label="姓名">
                <el-input v-model="formData.name"></el-input>
            </el-form-item>
            <el-form-item prop="sex" label="性别">
                <el-select v-model="formData.sex" clearable filterable placeholder="请选择">
                    <el-option v-for="item in sexOptions" :key="item.value" :label="item.label" :value="item.value">
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="idNo" label="证件号码">
                <el-input v-model="formData.idNo"></el-input>
            </el-form-item>
            <el-form-item prop="external" label="是否外聘">
                <el-switch v-model="formData.external"></el-switch>
            </el-form-item>
            <el-form-item prop="position" label="职称">
                <el-input v-model="formData.position"></el-input>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving" type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving" type="danger" v-if="formData.id">删除 </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
export default {
    name: 'RecordExpertEdit',
    created() {
        if (this.$route.query.id) {
            this.$http
                .get('recordExpert/get/' + this.$route.query.id)
                .then(res => {
                    this.formData = res;
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        }
    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {},
            sexOptions: [
                { label: '男', value: '男' },
                { label: '女', value: '女' }
            ]
        };
    },
    methods: {
        onSave() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            let data = { ...this.formData };

            this.saving = true;
            this.$http
                .post('/recordExpert/save', data, { body: 'json' })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/recordExpert/del/${this.formData.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error((e || {}).error || '删除失败');
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
